#version 100 sc_convert_to 300 es
#if defined VERTEX_SHADER
#define SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT




#include <std2.glsl>
#include <std2_vs.glsl>
#include <std2_fs.glsl>
#include <std2_texture.glsl>



varying vec4 varColor;
attribute vec4 color;

vec4 _3071;
mat3 _3073;
vec2 _3086;
vec3 _3097;

void ngsVertexShaderEnd(sc_Vertex_t v,vec3 WorldPosition,vec3 WorldNormal,vec3 WorldTangent,vec4 ScreenPosition)
{
varPos=WorldPosition;
varNormal=normalize(WorldNormal);
vec3 _2198=normalize(WorldTangent);
varTangent=vec4(_2198.x,_2198.y,_2198.z,varTangent.w);
varTangent.w=tangent.w;
#if (UseViewSpaceDepthVariant&&((sc_OITDepthGatherPass||sc_OITCompositingPass)||sc_OITDepthBoundsPass))
{
vec4 param=v.position;
varViewSpaceDepth=-sc_ObjectToView(param).z;
}
#endif
vec4 _3109;
#if (sc_RenderingSpace==3)
{
_3109=ScreenPosition;
}
#else
{
vec4 _3110;
#if (sc_RenderingSpace==4)
{
_3110=(sc_ModelViewMatrixArray[sc_GetStereoViewIndex()]*v.position)*vec4(1.0/sc_Camera.aspect,1.0,1.0,1.0);
}
#else
{
vec4 _3111;
#if (sc_RenderingSpace==2)
{
_3111=sc_ViewProjectionMatrixArray[sc_GetStereoViewIndex()]*vec4(varPos,1.0);
}
#else
{
vec4 _3112;
#if (sc_RenderingSpace==1)
{
_3112=sc_ViewProjectionMatrixArray[sc_GetStereoViewIndex()]*vec4(varPos,1.0);
}
#else
{
_3112=vec4(0.0);
}
#endif
_3111=_3112;
}
#endif
_3110=_3111;
}
#endif
_3109=_3110;
}
#endif
varPackedTex=vec4(v.texture0,v.texture1);
#if (sc_ProjectiveShadowsReceiver)
{
vec4 param_1=v.position;
varShadowTex=getProjectedTexCoords(param_1);
}
#endif
vec4 _3113;
#if (sc_DepthBufferMode==1)
{
vec4 _3048=_3109;
_3048.z=((log2(max(sc_Camera.clipPlanes.x,1.0+_3109.w))*(2.0/log2(sc_Camera.clipPlanes.y+1.0)))-1.0)*_3109.w;
_3113=_3048;
}
#else
{
_3113=_3109;
}
#endif
gl_Position=_3113;
}

void main()
{
sc_Vertex_t _2908=sc_LoadVertexAttributes();
sc_BlendVertex(_2908);
sc_Vertex_t _2909=_2908;
sc_SkinVertex(_2909);
sc_Vertex_t _2917=_2909;
#if (sc_RenderingSpace==3)
{
varPos=vec3(0.0);
varNormal=_2917.normal;
varTangent=vec4(_2917.tangent.x,_2917.tangent.y,_2917.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==4)
{
varPos=vec3(0.0);
varNormal=_2917.normal;
varTangent=vec4(_2917.tangent.x,_2917.tangent.y,_2917.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==2)
{
varPos=_2917.position.xyz;
varNormal=_2917.normal;
varTangent=vec4(_2917.tangent.x,_2917.tangent.y,_2917.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==1)
{
varPos=(sc_ModelMatrix*_2917.position).xyz;
varNormal=sc_NormalMatrix*_2917.normal;
vec3 _2934=sc_NormalMatrix*_2917.tangent;
varTangent=vec4(_2934.x,_2934.y,_2934.z,varTangent.w);
}
#endif
}
#endif
}
#endif
}
#endif
varColor=color;
sc_Vertex_t param=_2917;
vec3 param_1=varPos;
vec3 param_2=varNormal;
vec3 param_3=varTangent.xyz;
vec4 param_4=_2917.position;
ngsVertexShaderEnd(param,param_1,param_2,param_3,param_4);
}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#define SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT




#include <std2.glsl>
#include <std2_vs.glsl>
#include <std2_fs.glsl>
#include <std2_texture.glsl>

struct ssGlobals
{
highp float gTimeElapsed;
highp float gTimeDelta;
highp float gTimeElapsedShifted;
highp vec2 Surface_UVCoord0;
};

#ifndef BLEND_MODE_LIGHTEN
#define BLEND_MODE_LIGHTEN 0
#elif BLEND_MODE_LIGHTEN==1
#undef BLEND_MODE_LIGHTEN
#define BLEND_MODE_LIGHTEN 1
#endif
#ifndef BLEND_MODE_DARKEN
#define BLEND_MODE_DARKEN 0
#elif BLEND_MODE_DARKEN==1
#undef BLEND_MODE_DARKEN
#define BLEND_MODE_DARKEN 1
#endif
#ifndef BLEND_MODE_DIVIDE
#define BLEND_MODE_DIVIDE 0
#elif BLEND_MODE_DIVIDE==1
#undef BLEND_MODE_DIVIDE
#define BLEND_MODE_DIVIDE 1
#endif
#ifndef BLEND_MODE_AVERAGE
#define BLEND_MODE_AVERAGE 0
#elif BLEND_MODE_AVERAGE==1
#undef BLEND_MODE_AVERAGE
#define BLEND_MODE_AVERAGE 1
#endif
#ifndef BLEND_MODE_SUBTRACT
#define BLEND_MODE_SUBTRACT 0
#elif BLEND_MODE_SUBTRACT==1
#undef BLEND_MODE_SUBTRACT
#define BLEND_MODE_SUBTRACT 1
#endif
#ifndef BLEND_MODE_DIFFERENCE
#define BLEND_MODE_DIFFERENCE 0
#elif BLEND_MODE_DIFFERENCE==1
#undef BLEND_MODE_DIFFERENCE
#define BLEND_MODE_DIFFERENCE 1
#endif
#ifndef BLEND_MODE_NEGATION
#define BLEND_MODE_NEGATION 0
#elif BLEND_MODE_NEGATION==1
#undef BLEND_MODE_NEGATION
#define BLEND_MODE_NEGATION 1
#endif
#ifndef BLEND_MODE_EXCLUSION
#define BLEND_MODE_EXCLUSION 0
#elif BLEND_MODE_EXCLUSION==1
#undef BLEND_MODE_EXCLUSION
#define BLEND_MODE_EXCLUSION 1
#endif
#ifndef BLEND_MODE_OVERLAY
#define BLEND_MODE_OVERLAY 0
#elif BLEND_MODE_OVERLAY==1
#undef BLEND_MODE_OVERLAY
#define BLEND_MODE_OVERLAY 1
#endif
#ifndef BLEND_MODE_SOFT_LIGHT
#define BLEND_MODE_SOFT_LIGHT 0
#elif BLEND_MODE_SOFT_LIGHT==1
#undef BLEND_MODE_SOFT_LIGHT
#define BLEND_MODE_SOFT_LIGHT 1
#endif
#ifndef BLEND_MODE_HARD_LIGHT
#define BLEND_MODE_HARD_LIGHT 0
#elif BLEND_MODE_HARD_LIGHT==1
#undef BLEND_MODE_HARD_LIGHT
#define BLEND_MODE_HARD_LIGHT 1
#endif
#ifndef BLEND_MODE_COLOR_DODGE
#define BLEND_MODE_COLOR_DODGE 0
#elif BLEND_MODE_COLOR_DODGE==1
#undef BLEND_MODE_COLOR_DODGE
#define BLEND_MODE_COLOR_DODGE 1
#endif
#ifndef BLEND_MODE_COLOR_BURN
#define BLEND_MODE_COLOR_BURN 0
#elif BLEND_MODE_COLOR_BURN==1
#undef BLEND_MODE_COLOR_BURN
#define BLEND_MODE_COLOR_BURN 1
#endif
#ifndef BLEND_MODE_LINEAR_LIGHT
#define BLEND_MODE_LINEAR_LIGHT 0
#elif BLEND_MODE_LINEAR_LIGHT==1
#undef BLEND_MODE_LINEAR_LIGHT
#define BLEND_MODE_LINEAR_LIGHT 1
#endif
#ifndef BLEND_MODE_VIVID_LIGHT
#define BLEND_MODE_VIVID_LIGHT 0
#elif BLEND_MODE_VIVID_LIGHT==1
#undef BLEND_MODE_VIVID_LIGHT
#define BLEND_MODE_VIVID_LIGHT 1
#endif
#ifndef BLEND_MODE_PIN_LIGHT
#define BLEND_MODE_PIN_LIGHT 0
#elif BLEND_MODE_PIN_LIGHT==1
#undef BLEND_MODE_PIN_LIGHT
#define BLEND_MODE_PIN_LIGHT 1
#endif
#ifndef BLEND_MODE_HARD_MIX
#define BLEND_MODE_HARD_MIX 0
#elif BLEND_MODE_HARD_MIX==1
#undef BLEND_MODE_HARD_MIX
#define BLEND_MODE_HARD_MIX 1
#endif
#ifndef BLEND_MODE_HARD_REFLECT
#define BLEND_MODE_HARD_REFLECT 0
#elif BLEND_MODE_HARD_REFLECT==1
#undef BLEND_MODE_HARD_REFLECT
#define BLEND_MODE_HARD_REFLECT 1
#endif
#ifndef BLEND_MODE_HARD_GLOW
#define BLEND_MODE_HARD_GLOW 0
#elif BLEND_MODE_HARD_GLOW==1
#undef BLEND_MODE_HARD_GLOW
#define BLEND_MODE_HARD_GLOW 1
#endif
#ifndef BLEND_MODE_HARD_PHOENIX
#define BLEND_MODE_HARD_PHOENIX 0
#elif BLEND_MODE_HARD_PHOENIX==1
#undef BLEND_MODE_HARD_PHOENIX
#define BLEND_MODE_HARD_PHOENIX 1
#endif
#ifndef BLEND_MODE_HUE
#define BLEND_MODE_HUE 0
#elif BLEND_MODE_HUE==1
#undef BLEND_MODE_HUE
#define BLEND_MODE_HUE 1
#endif
#ifndef BLEND_MODE_SATURATION
#define BLEND_MODE_SATURATION 0
#elif BLEND_MODE_SATURATION==1
#undef BLEND_MODE_SATURATION
#define BLEND_MODE_SATURATION 1
#endif
#ifndef BLEND_MODE_COLOR
#define BLEND_MODE_COLOR 0
#elif BLEND_MODE_COLOR==1
#undef BLEND_MODE_COLOR
#define BLEND_MODE_COLOR 1
#endif
#ifndef BLEND_MODE_LUMINOSITY
#define BLEND_MODE_LUMINOSITY 0
#elif BLEND_MODE_LUMINOSITY==1
#undef BLEND_MODE_LUMINOSITY
#define BLEND_MODE_LUMINOSITY 1
#endif
#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef opacityTexHasSwappedViews
#define opacityTexHasSwappedViews 0
#elif opacityTexHasSwappedViews==1
#undef opacityTexHasSwappedViews
#define opacityTexHasSwappedViews 1
#endif
#ifndef opacityTexLayout
#define opacityTexLayout 0
#endif
#ifndef Tweak_N121
#define Tweak_N121 0
#elif Tweak_N121==1
#undef Tweak_N121
#define Tweak_N121 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef Tweak_N308
#define Tweak_N308 0
#elif Tweak_N308==1
#undef Tweak_N308
#define Tweak_N308 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_opacityTex
#define SC_SOFTWARE_WRAP_MODE_U_opacityTex -1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_opacityTex
#define SC_USE_CLAMP_TO_BORDER_opacityTex 0
#elif SC_USE_CLAMP_TO_BORDER_opacityTex==1
#undef SC_USE_CLAMP_TO_BORDER_opacityTex
#define SC_USE_CLAMP_TO_BORDER_opacityTex 1
#endif
#ifndef SC_USE_UV_MIN_MAX_opacityTex
#define SC_USE_UV_MIN_MAX_opacityTex 0
#elif SC_USE_UV_MIN_MAX_opacityTex==1
#undef SC_USE_UV_MIN_MAX_opacityTex
#define SC_USE_UV_MIN_MAX_opacityTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_opacityTex
#define SC_SOFTWARE_WRAP_MODE_V_opacityTex -1
#endif
#ifndef SC_USE_UV_TRANSFORM_opacityTex
#define SC_USE_UV_TRANSFORM_opacityTex 0
#elif SC_USE_UV_TRANSFORM_opacityTex==1
#undef SC_USE_UV_TRANSFORM_opacityTex
#define SC_USE_UV_TRANSFORM_opacityTex 1
#endif

uniform mediump sampler2D sc_OITFilteredDepthBoundsTexture;
uniform highp sampler2D sc_OITFrontDepthTexture;
uniform mediump sampler2D sc_OITDepthHigh0;
uniform mediump sampler2D sc_OITDepthLow0;
uniform mediump sampler2D sc_OITAlpha0;
uniform mediump sampler2D sc_OITDepthHigh1;
uniform mediump sampler2D sc_OITDepthLow1;
uniform mediump sampler2D sc_OITAlpha1;
uniform highp float alphaTestThreshold;
uniform highp vec4 baseTexDims;
uniform mediump sampler2DArray baseTexArrSC;
uniform mediump sampler2D baseTex;
uniform highp vec4 opacityTexDims;
uniform mediump sampler2DArray opacityTexArrSC;
uniform mediump sampler2D opacityTex;
uniform highp vec4 baseTexUvMinMax;
uniform highp mat3 baseTexTransform;
uniform highp vec4 baseTexBorderColor;
uniform highp float uvScale;
uniform highp vec4 opacityTexUvMinMax;
uniform highp mat3 opacityTexTransform;
uniform highp vec4 opacityTexBorderColor;
uniform bool overrideTimeEnable;
uniform highp float overrideTimeElapsed;
uniform highp float overrideTimeDelta;
uniform highp vec4 baseColor;

varying highp vec4 varColor;

float _7352;
vec4 _7432;
vec4 _7453;
vec4 _7621;
float _7679;

int baseTexGetStereoViewIndex()
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

highp vec4 baseTexSampleViewIndexBias(highp vec2 uv,int viewIndex,highp float bias)
{
#if (baseTexLayout==2)
{
highp vec2 param=baseTexDims.xy;
highp vec2 param_1=uv;
int param_2=baseTexLayout;
int param_3=viewIndex;
highp float param_4=bias;
return sc_SampleView(baseTexArrSC,param,param_1,param_2,param_3,param_4);
}
#else
{
highp vec2 param_5=baseTexDims.xy;
highp vec2 param_6=uv;
int param_7=baseTexLayout;
int param_8=viewIndex;
highp float param_9=bias;
return sc_SampleView(baseTex,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

void Node7_Texture_2D_Parameter(highp vec2 UVCoord,out highp vec4 Output,ssGlobals Globals)
{
highp vec2 _4462=UVCoord;
highp vec2 _7623;
highp float _7626;
#if ((SC_SOFTWARE_WRAP_MODE_U_baseTex==0)||(SC_SOFTWARE_WRAP_MODE_U_baseTex==3))
{
highp float _4473=clamp(_4462.x,0.0,1.0);
highp float _7629;
#if (SC_USE_CLAMP_TO_BORDER_baseTex&&(!SC_USE_UV_MIN_MAX_baseTex))
{
_7629=step(abs(_4462.x-_4473),1e-05);
}
#else
{
_7629=1.0;
}
#endif
highp vec2 _7298=_4462;
_7298.x=_4473;
_7626=_7629;
_7623=_7298;
}
#else
{
highp vec2 _7624;
#if (SC_SOFTWARE_WRAP_MODE_U_baseTex==1)
{
highp vec2 _7294=_4462;
_7294.x=fract(_4462.x);
_7624=_7294;
}
#else
{
highp vec2 _7625;
#if (SC_SOFTWARE_WRAP_MODE_U_baseTex==2)
{
highp float _4506=fract(_4462.x);
highp vec2 _7291=_4462;
_7291.x=mix(_4506,1.0-_4506,clamp(step(0.25,fract((_4462.x-_4506)*0.5)),0.0,1.0));
_7625=_7291;
}
#else
{
_7625=_4462;
}
#endif
_7624=_7625;
}
#endif
_7626=1.0;
_7623=_7624;
}
#endif
highp vec2 _7631;
highp float _7634;
#if ((SC_SOFTWARE_WRAP_MODE_V_baseTex==0)||(SC_SOFTWARE_WRAP_MODE_V_baseTex==3))
{
highp float _4534=clamp(_7623.y,0.0,1.0);
highp float _7637;
#if (SC_USE_CLAMP_TO_BORDER_baseTex&&(!SC_USE_UV_MIN_MAX_baseTex))
{
_7637=_7626*step(abs(_7623.y-_4534),1e-05);
}
#else
{
_7637=_7626;
}
#endif
highp vec2 _7309=_7623;
_7309.y=_4534;
_7634=_7637;
_7631=_7309;
}
#else
{
highp vec2 _7632;
#if (SC_SOFTWARE_WRAP_MODE_V_baseTex==1)
{
highp vec2 _7305=_7623;
_7305.y=fract(_7623.y);
_7632=_7305;
}
#else
{
highp vec2 _7633;
#if (SC_SOFTWARE_WRAP_MODE_V_baseTex==2)
{
highp float _4564=fract(_7623.y);
highp vec2 _7302=_7623;
_7302.y=mix(_4564,1.0-_4564,clamp(step(0.25,fract((_7623.y-_4564)*0.5)),0.0,1.0));
_7633=_7302;
}
#else
{
_7633=_7623;
}
#endif
_7632=_7633;
}
#endif
_7634=_7626;
_7631=_7632;
}
#endif
highp vec2 _7641;
highp float _7644;
#if (SC_USE_UV_MIN_MAX_baseTex)
{
highp float _4592=clamp(_7631.x,baseTexUvMinMax.x,baseTexUvMinMax.z);
highp float _7639;
#if (SC_USE_CLAMP_TO_BORDER_baseTex)
{
_7639=_7634*step(abs(_7631.x-_4592),1e-05);
}
#else
{
_7639=_7634;
}
#endif
highp vec2 _7313=_7631;
_7313.x=_4592;
highp float _4612=clamp(_7631.y,baseTexUvMinMax.y,baseTexUvMinMax.w);
highp float _7645;
#if (SC_USE_CLAMP_TO_BORDER_baseTex)
{
_7645=_7639*step(abs(_7631.y-_4612),1e-05);
}
#else
{
_7645=_7639;
}
#endif
highp vec2 _7317=_7313;
_7317.y=_4612;
_7644=_7645;
_7641=_7317;
}
#else
{
_7644=_7634;
_7641=_7631;
}
#endif
highp vec2 _7642;
#if (SC_USE_UV_TRANSFORM_baseTex)
{
_7642=vec2((baseTexTransform*vec3(_7641,1.0)).xy);
}
#else
{
_7642=_7641;
}
#endif
highp vec2 param=_7642;
highp vec2 _5288=quantizeUV(param);
int _5289=baseTexGetStereoViewIndex();
highp float _5290=0.0;
highp vec4 _5296=baseTexSampleViewIndexBias(_5288,_5289,_5290);
highp vec4 _7646;
#if (SC_USE_CLAMP_TO_BORDER_baseTex)
{
_7646=mix(baseTexBorderColor,_5296,vec4(_7644));
}
#else
{
_7646=_5296;
}
#endif
Output=_7646;
}

int opacityTexGetStereoViewIndex()
{
#if (opacityTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

highp vec4 opacityTexSampleViewIndexBias(highp vec2 uv,int viewIndex,highp float bias)
{
#if (opacityTexLayout==2)
{
highp vec2 param=opacityTexDims.xy;
highp vec2 param_1=uv;
int param_2=opacityTexLayout;
int param_3=viewIndex;
highp float param_4=bias;
return sc_SampleView(opacityTexArrSC,param,param_1,param_2,param_3,param_4);
}
#else
{
highp vec2 param_5=opacityTexDims.xy;
highp vec2 param_6=uv;
int param_7=opacityTexLayout;
int param_8=viewIndex;
highp float param_9=bias;
return sc_SampleView(opacityTex,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

void Node0_Texture_2D_Parameter(highp vec2 UVCoord,out highp vec4 Output,ssGlobals Globals)
{
highp vec2 _4692=UVCoord;
highp vec2 _7648;
highp float _7651;
#if ((SC_SOFTWARE_WRAP_MODE_U_opacityTex==0)||(SC_SOFTWARE_WRAP_MODE_U_opacityTex==3))
{
highp float _4703=clamp(_4692.x,0.0,1.0);
highp float _7654;
#if (SC_USE_CLAMP_TO_BORDER_opacityTex&&(!SC_USE_UV_MIN_MAX_opacityTex))
{
_7654=step(abs(_4692.x-_4703),1e-05);
}
#else
{
_7654=1.0;
}
#endif
highp vec2 _7328=_4692;
_7328.x=_4703;
_7651=_7654;
_7648=_7328;
}
#else
{
highp vec2 _7649;
#if (SC_SOFTWARE_WRAP_MODE_U_opacityTex==1)
{
highp vec2 _7324=_4692;
_7324.x=fract(_4692.x);
_7649=_7324;
}
#else
{
highp vec2 _7650;
#if (SC_SOFTWARE_WRAP_MODE_U_opacityTex==2)
{
highp float _4735=fract(_4692.x);
highp vec2 _7321=_4692;
_7321.x=mix(_4735,1.0-_4735,clamp(step(0.25,fract((_4692.x-_4735)*0.5)),0.0,1.0));
_7650=_7321;
}
#else
{
_7650=_4692;
}
#endif
_7649=_7650;
}
#endif
_7651=1.0;
_7648=_7649;
}
#endif
highp vec2 _7656;
highp float _7659;
#if ((SC_SOFTWARE_WRAP_MODE_V_opacityTex==0)||(SC_SOFTWARE_WRAP_MODE_V_opacityTex==3))
{
highp float _4762=clamp(_7648.y,0.0,1.0);
highp float _7662;
#if (SC_USE_CLAMP_TO_BORDER_opacityTex&&(!SC_USE_UV_MIN_MAX_opacityTex))
{
_7662=_7651*step(abs(_7648.y-_4762),1e-05);
}
#else
{
_7662=_7651;
}
#endif
highp vec2 _7339=_7648;
_7339.y=_4762;
_7659=_7662;
_7656=_7339;
}
#else
{
highp vec2 _7657;
#if (SC_SOFTWARE_WRAP_MODE_V_opacityTex==1)
{
highp vec2 _7335=_7648;
_7335.y=fract(_7648.y);
_7657=_7335;
}
#else
{
highp vec2 _7658;
#if (SC_SOFTWARE_WRAP_MODE_V_opacityTex==2)
{
highp float _4792=fract(_7648.y);
highp vec2 _7332=_7648;
_7332.y=mix(_4792,1.0-_4792,clamp(step(0.25,fract((_7648.y-_4792)*0.5)),0.0,1.0));
_7658=_7332;
}
#else
{
_7658=_7648;
}
#endif
_7657=_7658;
}
#endif
_7659=_7651;
_7656=_7657;
}
#endif
highp vec2 _7666;
highp float _7669;
#if (SC_USE_UV_MIN_MAX_opacityTex)
{
highp float _4820=clamp(_7656.x,opacityTexUvMinMax.x,opacityTexUvMinMax.z);
highp float _7664;
#if (SC_USE_CLAMP_TO_BORDER_opacityTex)
{
_7664=_7659*step(abs(_7656.x-_4820),1e-05);
}
#else
{
_7664=_7659;
}
#endif
highp vec2 _7343=_7656;
_7343.x=_4820;
highp float _4840=clamp(_7656.y,opacityTexUvMinMax.y,opacityTexUvMinMax.w);
highp float _7670;
#if (SC_USE_CLAMP_TO_BORDER_opacityTex)
{
_7670=_7664*step(abs(_7656.y-_4840),1e-05);
}
#else
{
_7670=_7664;
}
#endif
highp vec2 _7347=_7343;
_7347.y=_4840;
_7669=_7670;
_7666=_7347;
}
#else
{
_7669=_7659;
_7666=_7656;
}
#endif
highp vec2 _7667;
#if (SC_USE_UV_TRANSFORM_opacityTex)
{
_7667=vec2((opacityTexTransform*vec3(_7666,1.0)).xy);
}
#else
{
_7667=_7666;
}
#endif
highp vec2 param=_7667;
highp vec2 _5297=quantizeUV(param);
int _5298=opacityTexGetStereoViewIndex();
highp float _5299=0.0;
highp vec4 _5305=opacityTexSampleViewIndexBias(_5297,_5298,_5299);
highp vec4 _7671;
#if (SC_USE_CLAMP_TO_BORDER_opacityTex)
{
_7671=mix(opacityTexBorderColor,_5305,vec4(_7669));
}
#else
{
_7671=_5305;
}
#endif
Output=_7671;
}

highp vec3 definedBlend(highp vec3 a,highp vec3 b)
{
#if (BLEND_MODE_LIGHTEN)
{
return max(a,b);
}
#else
{
#if (BLEND_MODE_DARKEN)
{
return min(a,b);
}
#else
{
#if (BLEND_MODE_DIVIDE)
{
return b/a;
}
#else
{
#if (BLEND_MODE_AVERAGE)
{
return (a+b)*0.5;
}
#else
{
#if (BLEND_MODE_SUBTRACT)
{
return max((a+b)-vec3(1.0),vec3(0.0));
}
#else
{
#if (BLEND_MODE_DIFFERENCE)
{
return abs(a-b);
}
#else
{
#if (BLEND_MODE_NEGATION)
{
return vec3(1.0)-abs((vec3(1.0)-a)-b);
}
#else
{
#if (BLEND_MODE_EXCLUSION)
{
return (a+b)-((a*2.0)*b);
}
#else
{
#if (BLEND_MODE_OVERLAY)
{
highp float _7428;
if (a.x<0.5)
{
_7428=(2.0*a.x)*b.x;
}
else
{
_7428=1.0-((2.0*(1.0-a.x))*(1.0-b.x));
}
highp float _7429;
if (a.y<0.5)
{
_7429=(2.0*a.y)*b.y;
}
else
{
_7429=1.0-((2.0*(1.0-a.y))*(1.0-b.y));
}
highp float _7430;
if (a.z<0.5)
{
_7430=(2.0*a.z)*b.z;
}
else
{
_7430=1.0-((2.0*(1.0-a.z))*(1.0-b.z));
}
return vec3(_7428,_7429,_7430);
}
#else
{
#if (BLEND_MODE_SOFT_LIGHT)
{
return (((vec3(1.0)-(b*2.0))*a)*a)+((a*2.0)*b);
}
#else
{
#if (BLEND_MODE_HARD_LIGHT)
{
highp float _7425;
if (b.x<0.5)
{
_7425=(2.0*b.x)*a.x;
}
else
{
_7425=1.0-((2.0*(1.0-b.x))*(1.0-a.x));
}
highp float _7426;
if (b.y<0.5)
{
_7426=(2.0*b.y)*a.y;
}
else
{
_7426=1.0-((2.0*(1.0-b.y))*(1.0-a.y));
}
highp float _7427;
if (b.z<0.5)
{
_7427=(2.0*b.z)*a.z;
}
else
{
_7427=1.0-((2.0*(1.0-b.z))*(1.0-a.z));
}
return vec3(_7425,_7426,_7427);
}
#else
{
#if (BLEND_MODE_COLOR_DODGE)
{
highp float _7422;
if (b.x==1.0)
{
_7422=b.x;
}
else
{
_7422=min(a.x/(1.0-b.x),1.0);
}
highp float _7423;
if (b.y==1.0)
{
_7423=b.y;
}
else
{
_7423=min(a.y/(1.0-b.y),1.0);
}
highp float _7424;
if (b.z==1.0)
{
_7424=b.z;
}
else
{
_7424=min(a.z/(1.0-b.z),1.0);
}
return vec3(_7422,_7423,_7424);
}
#else
{
#if (BLEND_MODE_COLOR_BURN)
{
highp float _7419;
if (b.x==0.0)
{
_7419=b.x;
}
else
{
_7419=max(1.0-((1.0-a.x)/b.x),0.0);
}
highp float _7420;
if (b.y==0.0)
{
_7420=b.y;
}
else
{
_7420=max(1.0-((1.0-a.y)/b.y),0.0);
}
highp float _7421;
if (b.z==0.0)
{
_7421=b.z;
}
else
{
_7421=max(1.0-((1.0-a.z)/b.z),0.0);
}
return vec3(_7419,_7420,_7421);
}
#else
{
#if (BLEND_MODE_LINEAR_LIGHT)
{
highp float _7416;
if (b.x<0.5)
{
_7416=max((a.x+(2.0*b.x))-1.0,0.0);
}
else
{
_7416=min(a.x+(2.0*(b.x-0.5)),1.0);
}
highp float _7417;
if (b.y<0.5)
{
_7417=max((a.y+(2.0*b.y))-1.0,0.0);
}
else
{
_7417=min(a.y+(2.0*(b.y-0.5)),1.0);
}
highp float _7418;
if (b.z<0.5)
{
_7418=max((a.z+(2.0*b.z))-1.0,0.0);
}
else
{
_7418=min(a.z+(2.0*(b.z-0.5)),1.0);
}
return vec3(_7416,_7417,_7418);
}
#else
{
#if (BLEND_MODE_VIVID_LIGHT)
{
highp float _7409;
if (b.x<0.5)
{
highp float _7408;
if ((2.0*b.x)==0.0)
{
_7408=2.0*b.x;
}
else
{
_7408=max(1.0-((1.0-a.x)/(2.0*b.x)),0.0);
}
_7409=_7408;
}
else
{
highp float _7407;
if ((2.0*(b.x-0.5))==1.0)
{
_7407=2.0*(b.x-0.5);
}
else
{
_7407=min(a.x/(1.0-(2.0*(b.x-0.5))),1.0);
}
_7409=_7407;
}
highp float _7412;
if (b.y<0.5)
{
highp float _7411;
if ((2.0*b.y)==0.0)
{
_7411=2.0*b.y;
}
else
{
_7411=max(1.0-((1.0-a.y)/(2.0*b.y)),0.0);
}
_7412=_7411;
}
else
{
highp float _7410;
if ((2.0*(b.y-0.5))==1.0)
{
_7410=2.0*(b.y-0.5);
}
else
{
_7410=min(a.y/(1.0-(2.0*(b.y-0.5))),1.0);
}
_7412=_7410;
}
highp float _7415;
if (b.z<0.5)
{
highp float _7414;
if ((2.0*b.z)==0.0)
{
_7414=2.0*b.z;
}
else
{
_7414=max(1.0-((1.0-a.z)/(2.0*b.z)),0.0);
}
_7415=_7414;
}
else
{
highp float _7413;
if ((2.0*(b.z-0.5))==1.0)
{
_7413=2.0*(b.z-0.5);
}
else
{
_7413=min(a.z/(1.0-(2.0*(b.z-0.5))),1.0);
}
_7415=_7413;
}
return vec3(_7409,_7412,_7415);
}
#else
{
#if (BLEND_MODE_PIN_LIGHT)
{
highp float _7404;
if (b.x<0.5)
{
_7404=min(a.x,2.0*b.x);
}
else
{
_7404=max(a.x,2.0*(b.x-0.5));
}
highp float _7405;
if (b.y<0.5)
{
_7405=min(a.y,2.0*b.y);
}
else
{
_7405=max(a.y,2.0*(b.y-0.5));
}
highp float _7406;
if (b.z<0.5)
{
_7406=min(a.z,2.0*b.z);
}
else
{
_7406=max(a.z,2.0*(b.z-0.5));
}
return vec3(_7404,_7405,_7406);
}
#else
{
#if (BLEND_MODE_HARD_MIX)
{
highp float _7397;
if (b.x<0.5)
{
highp float _7396;
if ((2.0*b.x)==0.0)
{
_7396=2.0*b.x;
}
else
{
_7396=max(1.0-((1.0-a.x)/(2.0*b.x)),0.0);
}
_7397=_7396;
}
else
{
highp float _7395;
if ((2.0*(b.x-0.5))==1.0)
{
_7395=2.0*(b.x-0.5);
}
else
{
_7395=min(a.x/(1.0-(2.0*(b.x-0.5))),1.0);
}
_7397=_7395;
}
bool _2968=_7397<0.5;
highp float _7400;
if (b.y<0.5)
{
highp float _7399;
if ((2.0*b.y)==0.0)
{
_7399=2.0*b.y;
}
else
{
_7399=max(1.0-((1.0-a.y)/(2.0*b.y)),0.0);
}
_7400=_7399;
}
else
{
highp float _7398;
if ((2.0*(b.y-0.5))==1.0)
{
_7398=2.0*(b.y-0.5);
}
else
{
_7398=min(a.y/(1.0-(2.0*(b.y-0.5))),1.0);
}
_7400=_7398;
}
bool _3022=_7400<0.5;
highp float _7403;
if (b.z<0.5)
{
highp float _7402;
if ((2.0*b.z)==0.0)
{
_7402=2.0*b.z;
}
else
{
_7402=max(1.0-((1.0-a.z)/(2.0*b.z)),0.0);
}
_7403=_7402;
}
else
{
highp float _7401;
if ((2.0*(b.z-0.5))==1.0)
{
_7401=2.0*(b.z-0.5);
}
else
{
_7401=min(a.z/(1.0-(2.0*(b.z-0.5))),1.0);
}
_7403=_7401;
}
return vec3(_2968 ? 0.0 : 1.0,_3022 ? 0.0 : 1.0,(_7403<0.5) ? 0.0 : 1.0);
}
#else
{
#if (BLEND_MODE_HARD_REFLECT)
{
highp float _7392;
if (b.x==1.0)
{
_7392=b.x;
}
else
{
_7392=min((a.x*a.x)/(1.0-b.x),1.0);
}
highp float _7393;
if (b.y==1.0)
{
_7393=b.y;
}
else
{
_7393=min((a.y*a.y)/(1.0-b.y),1.0);
}
highp float _7394;
if (b.z==1.0)
{
_7394=b.z;
}
else
{
_7394=min((a.z*a.z)/(1.0-b.z),1.0);
}
return vec3(_7392,_7393,_7394);
}
#else
{
#if (BLEND_MODE_HARD_GLOW)
{
highp float _7389;
if (a.x==1.0)
{
_7389=a.x;
}
else
{
_7389=min((b.x*b.x)/(1.0-a.x),1.0);
}
highp float _7390;
if (a.y==1.0)
{
_7390=a.y;
}
else
{
_7390=min((b.y*b.y)/(1.0-a.y),1.0);
}
highp float _7391;
if (a.z==1.0)
{
_7391=a.z;
}
else
{
_7391=min((b.z*b.z)/(1.0-a.z),1.0);
}
return vec3(_7389,_7390,_7391);
}
#else
{
#if (BLEND_MODE_HARD_PHOENIX)
{
return (min(a,b)-max(a,b))+vec3(1.0);
}
#else
{
#if (BLEND_MODE_HUE)
{
highp vec3 _3230=a;
highp vec3 _3232=b;
highp vec4 _7385;
if (_3230.y<_3230.z)
{
_7385=vec4(_3230.zy,-1.0,0.666667);
}
else
{
_7385=vec4(_3230.yz,0.0,-0.333333);
}
highp vec4 _7386;
if (_3230.x<_7385.x)
{
_7386=vec4(_7385.xy,_7679,_3230.x);
}
else
{
_7386=vec4(_3230.x,_7385.y,_7679,_7385.x);
}
highp float _6860=_7386.x-min(_7386.w,_7386.y);
highp float _6785=_7386.x-(_6860*0.5);
highp float _6791=abs((2.0*_6785)-1.0);
highp vec4 _7387;
if (_3232.y<_3232.z)
{
_7387=vec4(_3232.zy,-1.0,0.666667);
}
else
{
_7387=vec4(_3232.yz,0.0,-0.333333);
}
highp vec4 _7388;
if (_3232.x<_7387.x)
{
_7388=vec4(_7387.xyw,_3232.x);
}
else
{
_7388=vec4(_3232.x,_7387.yzx);
}
highp float _7021=6.0*abs(((_7388.w-_7388.y)/((6.0*(_7388.x-min(_7388.w,_7388.y)))+1e-07))+_7388.z);
return ((clamp(vec3(abs(_7021-3.0)-1.0,2.0-abs(_7021-2.0),2.0-abs(_7021-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-_6791)*(_6860/(1.0-_6791))))+vec3(_6785);
}
#else
{
#if (BLEND_MODE_SATURATION)
{
highp vec3 _3240=a;
highp vec3 _3242=b;
highp vec4 _7381;
if (_3240.y<_3240.z)
{
_7381=vec4(_3240.zy,-1.0,0.666667);
}
else
{
_7381=vec4(_3240.yz,0.0,-0.333333);
}
highp vec4 _7382;
if (_3240.x<_7381.x)
{
_7382=vec4(_7381.xyw,_3240.x);
}
else
{
_7382=vec4(_3240.x,_7381.yzx);
}
highp float _6573=_7382.x-min(_7382.w,_7382.y);
highp float _6498=_7382.x-(_6573*0.5);
highp vec4 _7383;
if (_3242.y<_3242.z)
{
_7383=vec4(_3242.zy,-1.0,0.666667);
}
else
{
_7383=vec4(_3242.yz,0.0,-0.333333);
}
highp vec4 _7384;
if (_3242.x<_7383.x)
{
_7384=vec4(_7383.xy,_7679,_3242.x);
}
else
{
_7384=vec4(_3242.x,_7383.y,_7679,_7383.x);
}
highp float _6681=_7384.x-min(_7384.w,_7384.y);
highp float _6734=6.0*abs(((_7382.w-_7382.y)/((6.0*_6573)+1e-07))+_7382.z);
return ((clamp(vec3(abs(_6734-3.0)-1.0,2.0-abs(_6734-2.0),2.0-abs(_6734-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_6498)-1.0))*(_6681/(1.0-abs((2.0*(_7384.x-(_6681*0.5)))-1.0)))))+vec3(_6498);
}
#else
{
#if (BLEND_MODE_COLOR)
{
highp vec3 _3250=a;
highp vec3 _3252=b;
highp vec4 _7377;
if (_3252.y<_3252.z)
{
_7377=vec4(_3252.zy,-1.0,0.666667);
}
else
{
_7377=vec4(_3252.yz,0.0,-0.333333);
}
highp vec4 _7378;
if (_3252.x<_7377.x)
{
_7378=vec4(_7377.xyw,_3252.x);
}
else
{
_7378=vec4(_3252.x,_7377.yzx);
}
highp float _6286=_7378.x-min(_7378.w,_7378.y);
highp vec4 _7379;
if (_3250.y<_3250.z)
{
_7379=vec4(_3250.zy,-1.0,0.666667);
}
else
{
_7379=vec4(_3250.yz,0.0,-0.333333);
}
highp vec4 _7380;
if (_3250.x<_7379.x)
{
_7380=vec4(_7379.xy,_7679,_3250.x);
}
else
{
_7380=vec4(_3250.x,_7379.y,_7679,_7379.x);
}
highp float _6319=_7380.x-((_7380.x-min(_7380.w,_7380.y))*0.5);
highp float _6447=6.0*abs(((_7378.w-_7378.y)/((6.0*_6286)+1e-07))+_7378.z);
return ((clamp(vec3(abs(_6447-3.0)-1.0,2.0-abs(_6447-2.0),2.0-abs(_6447-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_6319)-1.0))*(_6286/(1.0-abs((2.0*(_7378.x-(_6286*0.5)))-1.0)))))+vec3(_6319);
}
#else
{
#if (BLEND_MODE_LUMINOSITY)
{
highp vec3 _3260=a;
highp vec3 _3262=b;
highp vec4 _7373;
if (_3260.y<_3260.z)
{
_7373=vec4(_3260.zy,-1.0,0.666667);
}
else
{
_7373=vec4(_3260.yz,0.0,-0.333333);
}
highp vec4 _7374;
if (_3260.x<_7373.x)
{
_7374=vec4(_7373.xyw,_3260.x);
}
else
{
_7374=vec4(_3260.x,_7373.yzx);
}
highp float _5999=_7374.x-min(_7374.w,_7374.y);
highp vec4 _7375;
if (_3262.y<_3262.z)
{
_7375=vec4(_3262.zy,-1.0,0.666667);
}
else
{
_7375=vec4(_3262.yz,0.0,-0.333333);
}
highp vec4 _7376;
if (_3262.x<_7375.x)
{
_7376=vec4(_7375.xy,_7679,_3262.x);
}
else
{
_7376=vec4(_3262.x,_7375.y,_7679,_7375.x);
}
highp float _6032=_7376.x-((_7376.x-min(_7376.w,_7376.y))*0.5);
highp float _6160=6.0*abs(((_7374.w-_7374.y)/((6.0*_5999)+1e-07))+_7374.z);
return ((clamp(vec3(abs(_6160-3.0)-1.0,2.0-abs(_6160-2.0),2.0-abs(_6160-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_6032)-1.0))*(_5999/(1.0-abs((2.0*(_7374.x-(_5999*0.5)))-1.0)))))+vec3(_6032);
}
#else
{
return vec3(0.0);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}

highp vec4 ngsPixelShader(inout highp vec4 result)
{
#if (sc_ProjectiveShadowsCaster)
{
highp vec4 param=result;
return evaluateShadowCasterColor(param);
}
#else
{
#if (sc_BlendMode_Custom)
{
highp vec3 _5313=getFramebufferColor().xyz;
highp vec3 _5308=_5313;
highp vec3 _5309=result.xyz;
highp vec3 _5326=mix(_5313,definedBlend(_5308,_5309).xyz,vec3(result.w));
highp vec4 _7287=vec4(_5326.x,_5326.y,_5326.z,_7621.w);
_7287.w=1.0;
result=_7287;
}
#else
{
#if (sc_BlendMode_MultiplyOriginal)
{
highp vec3 _4056=mix(vec3(1.0),result.xyz,vec3(result.w));
result=vec4(_4056.x,_4056.y,_4056.z,result.w);
}
#else
{
#if (sc_BlendMode_Screen)
{
highp vec3 _4066=result.xyz*result.w;
result=vec4(_4066.x,_4066.y,_4066.z,result.w);
}
#endif
}
#endif
}
#endif
return result;
}
#endif
}

highp float getFrontLayerZTestEpsilon()
{
#if (sc_SkinBonesCount>0)
{
return 5e-07;
}
#else
{
return 5e-08;
}
#endif
}

highp float getDepthOrderingEpsilon()
{
#if (sc_SkinBonesCount>0)
{
return 0.001;
}
#else
{
return 0.0;
}
#endif
}

highp float viewSpaceDepth()
{
#if (UseViewSpaceDepthVariant&&((sc_OITDepthGatherPass||sc_OITCompositingPass)||sc_OITDepthBoundsPass))
{
return varViewSpaceDepth;
}
#else
{
return sc_ProjectionMatrixArray[sc_GetStereoViewIndex()][3].z/(sc_ProjectionMatrixArray[sc_GetStereoViewIndex()][2].z+((gl_FragCoord.z*2.0)-1.0));
}
#endif
}

void oitCompositing(highp vec4 materialColor)
{
#if (sc_OITCompositingPass)
{
highp vec2 _3597=getScreenUV();
#if (sc_OITMaxLayers4Plus1)
{
if ((gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,_3597).x)<=getFrontLayerZTestEpsilon())
{
discard;
}
}
#endif
int depths[8];
int alphas[8];
for (int _7435=0; _7435<8; depths[_7435]=0,alphas[_7435]=0,_7435++)
{
}
int _7438;
#if (sc_OITMaxLayers8)
{
_7438=2;
}
#else
{
_7438=1;
}
#endif
highp vec4 _7449;
highp vec4 _7456;
highp vec4 _7513;
_7513=_7453;
_7456=_7453;
_7449=_7453;
highp vec4 _7447;
highp vec4 _7454;
highp vec4 _7511;
for (int _7436=0; _7436<_7438; _7513=_7511,_7456=_7454,_7449=_7447,_7436++)
{
highp vec4 _7448;
highp vec4 _7455;
highp vec4 _7512;
if (_7436==0)
{
_7512=texture2D(sc_OITAlpha0,_3597);
_7455=texture2D(sc_OITDepthLow0,_3597);
_7448=texture2D(sc_OITDepthHigh0,_3597);
}
else
{
_7512=_7513;
_7455=_7456;
_7448=_7449;
}
if (_7436==1)
{
_7511=texture2D(sc_OITAlpha1,_3597);
_7454=texture2D(sc_OITDepthLow1,_3597);
_7447=texture2D(sc_OITDepthHigh1,_3597);
}
else
{
_7511=_7512;
_7454=_7455;
_7447=_7448;
}
if (any(notEqual(_7447,vec4(0.0)))||any(notEqual(_7454,vec4(0.0))))
{
int param[8];
param[0]=depths[0];
param[1]=depths[1];
param[2]=depths[2];
param[3]=depths[3];
param[4]=depths[4];
param[5]=depths[5];
param[6]=depths[6];
param[7]=depths[7];
#if (sc_OITCompositingPass)
{
int _7461=((_7436+1)*4)-1;
highp float _7557=floor((_7447.w*255.0)+0.5);
for (; _7461>=(_7436*4); param[_7461]=(param[_7461]*4)+int(floor(mod(_7557,4.0))),_7557=floor(_7557*0.25),_7461--)
{
}
}
#endif
depths[0]=param[0];
depths[1]=param[1];
depths[2]=param[2];
depths[3]=param[3];
depths[4]=param[4];
depths[5]=param[5];
depths[6]=param[6];
depths[7]=param[7];
int param_1[8];
param_1[0]=param[0];
param_1[1]=param[1];
param_1[2]=param[2];
param_1[3]=param[3];
param_1[4]=param[4];
param_1[5]=param[5];
param_1[6]=param[6];
param_1[7]=param[7];
#if (sc_OITCompositingPass)
{
int _7466=((_7436+1)*4)-1;
highp float _7556=floor((_7447.z*255.0)+0.5);
for (; _7466>=(_7436*4); param_1[_7466]=(param_1[_7466]*4)+int(floor(mod(_7556,4.0))),_7556=floor(_7556*0.25),_7466--)
{
}
}
#endif
depths[0]=param_1[0];
depths[1]=param_1[1];
depths[2]=param_1[2];
depths[3]=param_1[3];
depths[4]=param_1[4];
depths[5]=param_1[5];
depths[6]=param_1[6];
depths[7]=param_1[7];
int param_2[8];
param_2[0]=param_1[0];
param_2[1]=param_1[1];
param_2[2]=param_1[2];
param_2[3]=param_1[3];
param_2[4]=param_1[4];
param_2[5]=param_1[5];
param_2[6]=param_1[6];
param_2[7]=param_1[7];
#if (sc_OITCompositingPass)
{
int _7471=((_7436+1)*4)-1;
highp float _7555=floor((_7447.y*255.0)+0.5);
for (; _7471>=(_7436*4); param_2[_7471]=(param_2[_7471]*4)+int(floor(mod(_7555,4.0))),_7555=floor(_7555*0.25),_7471--)
{
}
}
#endif
depths[0]=param_2[0];
depths[1]=param_2[1];
depths[2]=param_2[2];
depths[3]=param_2[3];
depths[4]=param_2[4];
depths[5]=param_2[5];
depths[6]=param_2[6];
depths[7]=param_2[7];
int param_3[8];
param_3[0]=param_2[0];
param_3[1]=param_2[1];
param_3[2]=param_2[2];
param_3[3]=param_2[3];
param_3[4]=param_2[4];
param_3[5]=param_2[5];
param_3[6]=param_2[6];
param_3[7]=param_2[7];
#if (sc_OITCompositingPass)
{
int _7476=((_7436+1)*4)-1;
highp float _7554=floor((_7447.x*255.0)+0.5);
for (; _7476>=(_7436*4); param_3[_7476]=(param_3[_7476]*4)+int(floor(mod(_7554,4.0))),_7554=floor(_7554*0.25),_7476--)
{
}
}
#endif
depths[0]=param_3[0];
depths[1]=param_3[1];
depths[2]=param_3[2];
depths[3]=param_3[3];
depths[4]=param_3[4];
depths[5]=param_3[5];
depths[6]=param_3[6];
depths[7]=param_3[7];
int param_4[8];
param_4[0]=param_3[0];
param_4[1]=param_3[1];
param_4[2]=param_3[2];
param_4[3]=param_3[3];
param_4[4]=param_3[4];
param_4[5]=param_3[5];
param_4[6]=param_3[6];
param_4[7]=param_3[7];
#if (sc_OITCompositingPass)
{
int _7487=((_7436+1)*4)-1;
highp float _7553=floor((_7454.w*255.0)+0.5);
for (; _7487>=(_7436*4); param_4[_7487]=(param_4[_7487]*4)+int(floor(mod(_7553,4.0))),_7553=floor(_7553*0.25),_7487--)
{
}
}
#endif
depths[0]=param_4[0];
depths[1]=param_4[1];
depths[2]=param_4[2];
depths[3]=param_4[3];
depths[4]=param_4[4];
depths[5]=param_4[5];
depths[6]=param_4[6];
depths[7]=param_4[7];
int param_5[8];
param_5[0]=param_4[0];
param_5[1]=param_4[1];
param_5[2]=param_4[2];
param_5[3]=param_4[3];
param_5[4]=param_4[4];
param_5[5]=param_4[5];
param_5[6]=param_4[6];
param_5[7]=param_4[7];
#if (sc_OITCompositingPass)
{
int _7492=((_7436+1)*4)-1;
highp float _7552=floor((_7454.z*255.0)+0.5);
for (; _7492>=(_7436*4); param_5[_7492]=(param_5[_7492]*4)+int(floor(mod(_7552,4.0))),_7552=floor(_7552*0.25),_7492--)
{
}
}
#endif
depths[0]=param_5[0];
depths[1]=param_5[1];
depths[2]=param_5[2];
depths[3]=param_5[3];
depths[4]=param_5[4];
depths[5]=param_5[5];
depths[6]=param_5[6];
depths[7]=param_5[7];
int param_6[8];
param_6[0]=param_5[0];
param_6[1]=param_5[1];
param_6[2]=param_5[2];
param_6[3]=param_5[3];
param_6[4]=param_5[4];
param_6[5]=param_5[5];
param_6[6]=param_5[6];
param_6[7]=param_5[7];
#if (sc_OITCompositingPass)
{
int _7497=((_7436+1)*4)-1;
highp float _7551=floor((_7454.y*255.0)+0.5);
for (; _7497>=(_7436*4); param_6[_7497]=(param_6[_7497]*4)+int(floor(mod(_7551,4.0))),_7551=floor(_7551*0.25),_7497--)
{
}
}
#endif
depths[0]=param_6[0];
depths[1]=param_6[1];
depths[2]=param_6[2];
depths[3]=param_6[3];
depths[4]=param_6[4];
depths[5]=param_6[5];
depths[6]=param_6[6];
depths[7]=param_6[7];
int param_7[8];
param_7[0]=param_6[0];
param_7[1]=param_6[1];
param_7[2]=param_6[2];
param_7[3]=param_6[3];
param_7[4]=param_6[4];
param_7[5]=param_6[5];
param_7[6]=param_6[6];
param_7[7]=param_6[7];
#if (sc_OITCompositingPass)
{
int _7502=((_7436+1)*4)-1;
highp float _7550=floor((_7454.x*255.0)+0.5);
for (; _7502>=(_7436*4); param_7[_7502]=(param_7[_7502]*4)+int(floor(mod(_7550,4.0))),_7550=floor(_7550*0.25),_7502--)
{
}
}
#endif
depths[0]=param_7[0];
depths[1]=param_7[1];
depths[2]=param_7[2];
depths[3]=param_7[3];
depths[4]=param_7[4];
depths[5]=param_7[5];
depths[6]=param_7[6];
depths[7]=param_7[7];
int param_8[8];
param_8[0]=alphas[0];
param_8[1]=alphas[1];
param_8[2]=alphas[2];
param_8[3]=alphas[3];
param_8[4]=alphas[4];
param_8[5]=alphas[5];
param_8[6]=alphas[6];
param_8[7]=alphas[7];
#if (sc_OITCompositingPass)
{
int _7527=((_7436+1)*4)-1;
highp float _7549=floor((_7511.w*255.0)+0.5);
for (; _7527>=(_7436*4); param_8[_7527]=(param_8[_7527]*4)+int(floor(mod(_7549,4.0))),_7549=floor(_7549*0.25),_7527--)
{
}
}
#endif
alphas[0]=param_8[0];
alphas[1]=param_8[1];
alphas[2]=param_8[2];
alphas[3]=param_8[3];
alphas[4]=param_8[4];
alphas[5]=param_8[5];
alphas[6]=param_8[6];
alphas[7]=param_8[7];
int param_9[8];
param_9[0]=param_8[0];
param_9[1]=param_8[1];
param_9[2]=param_8[2];
param_9[3]=param_8[3];
param_9[4]=param_8[4];
param_9[5]=param_8[5];
param_9[6]=param_8[6];
param_9[7]=param_8[7];
#if (sc_OITCompositingPass)
{
int _7532=((_7436+1)*4)-1;
highp float _7548=floor((_7511.z*255.0)+0.5);
for (; _7532>=(_7436*4); param_9[_7532]=(param_9[_7532]*4)+int(floor(mod(_7548,4.0))),_7548=floor(_7548*0.25),_7532--)
{
}
}
#endif
alphas[0]=param_9[0];
alphas[1]=param_9[1];
alphas[2]=param_9[2];
alphas[3]=param_9[3];
alphas[4]=param_9[4];
alphas[5]=param_9[5];
alphas[6]=param_9[6];
alphas[7]=param_9[7];
int param_10[8];
param_10[0]=param_9[0];
param_10[1]=param_9[1];
param_10[2]=param_9[2];
param_10[3]=param_9[3];
param_10[4]=param_9[4];
param_10[5]=param_9[5];
param_10[6]=param_9[6];
param_10[7]=param_9[7];
#if (sc_OITCompositingPass)
{
int _7537=((_7436+1)*4)-1;
highp float _7547=floor((_7511.y*255.0)+0.5);
for (; _7537>=(_7436*4); param_10[_7537]=(param_10[_7537]*4)+int(floor(mod(_7547,4.0))),_7547=floor(_7547*0.25),_7537--)
{
}
}
#endif
alphas[0]=param_10[0];
alphas[1]=param_10[1];
alphas[2]=param_10[2];
alphas[3]=param_10[3];
alphas[4]=param_10[4];
alphas[5]=param_10[5];
alphas[6]=param_10[6];
alphas[7]=param_10[7];
int param_11[8];
param_11[0]=param_10[0];
param_11[1]=param_10[1];
param_11[2]=param_10[2];
param_11[3]=param_10[3];
param_11[4]=param_10[4];
param_11[5]=param_10[5];
param_11[6]=param_10[6];
param_11[7]=param_10[7];
#if (sc_OITCompositingPass)
{
int _7542=((_7436+1)*4)-1;
highp float _7546=floor((_7511.x*255.0)+0.5);
for (; _7542>=(_7436*4); param_11[_7542]=(param_11[_7542]*4)+int(floor(mod(_7546,4.0))),_7546=floor(_7546*0.25),_7542--)
{
}
}
#endif
alphas[0]=param_11[0];
alphas[1]=param_11[1];
alphas[2]=param_11[2];
alphas[3]=param_11[3];
alphas[4]=param_11[4];
alphas[5]=param_11[5];
alphas[6]=param_11[6];
alphas[7]=param_11[7];
}
continue;
}
vec4 _5783=texture2D(sc_OITFilteredDepthBoundsTexture,_3597);
int _7442;
#if (sc_SkinBonesCount>0)
{
highp float _5793=(1.0-_5783.x)*1000.0;
_7442=int(clamp(((_5793+getDepthOrderingEpsilon())-_5793)/((_5783.y*1000.0)-_5793),0.0,1.0)*65535.0);
}
#else
{
_7442=0;
}
#endif
highp float _5830=(1.0-_5783.x)*1000.0;
highp vec4 _7440;
_7440=materialColor*materialColor.w;
highp vec4 _7585;
for (int _7439=0; _7439<8; _7440=_7585,_7439++)
{
int _3834=depths[_7439];
int _3837=int(clamp((viewSpaceDepth()-_5830)/((_5783.y*1000.0)-_5830),0.0,1.0)*65535.0)-_7442;
bool _3838=_3834<_3837;
bool _3845;
if (_3838)
{
_3845=depths[_7439]>0;
}
else
{
_3845=_3838;
}
if (_3845)
{
highp vec3 _3856=_7440.xyz*(1.0-(float(alphas[_7439])*0.00392157));
_7585=vec4(_3856.x,_3856.y,_3856.z,_7440.w);
}
else
{
_7585=_7440;
}
continue;
}
highp vec4 param_12=_7440;
sc_writeFragData0(param_12);
#if (sc_OITMaxLayersVisualizeLayerCount)
{
discard;
}
#endif
}
#endif
}

highp float packValue(inout int value)
{
#if (sc_OITDepthGatherPass)
{
int _3411=value;
value/=4;
return floor(floor(mod(float(_3411),4.0))*64.0)*0.00392157;
}
#else
{
return 0.0;
}
#endif
}

void oitDepthGather(highp vec4 materialColor)
{
#if (sc_OITDepthGatherPass)
{
highp vec2 _3467=getScreenUV();
#if (sc_OITMaxLayers4Plus1)
{
if ((gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,_3467).x)<=getFrontLayerZTestEpsilon())
{
discard;
}
}
#endif
vec4 _5853=texture2D(sc_OITFilteredDepthBoundsTexture,_3467);
highp float _5863=(1.0-_5853.x)*1000.0;
int param=int(clamp((viewSpaceDepth()-_5863)/((_5853.y*1000.0)-_5863),0.0,1.0)*65535.0);
highp float _3505=packValue(param);
highp vec4 _7243=_7432;
_7243.x=_3505;
int param_1=param;
highp float _3510=packValue(param_1);
highp vec4 _7245=_7243;
_7245.y=_3510;
int param_2=param_1;
highp float _3515=packValue(param_2);
highp vec4 _7247=_7245;
_7247.z=_3515;
int param_3=param_2;
highp float _3520=packValue(param_3);
highp vec4 _7249=_7247;
_7249.w=_3520;
int param_4=param_3;
highp float _3526=packValue(param_4);
highp vec4 _7251=_7432;
_7251.x=_3526;
int param_5=param_4;
highp float _3531=packValue(param_5);
highp vec4 _7253=_7251;
_7253.y=_3531;
int param_6=param_5;
highp float _3536=packValue(param_6);
highp vec4 _7255=_7253;
_7255.z=_3536;
int param_7=param_6;
highp float _3541=packValue(param_7);
highp vec4 _7257=_7255;
_7257.w=_3541;
int param_8=int(materialColor.w*255.0);
highp float _3547=packValue(param_8);
highp vec4 _7259=_7432;
_7259.x=_3547;
int param_9=param_8;
highp float _3552=packValue(param_9);
highp vec4 _7261=_7259;
_7261.y=_3552;
int param_10=param_9;
highp float _3557=packValue(param_10);
highp vec4 _7263=_7261;
_7263.z=_3557;
int param_11=param_10;
highp float _3562=packValue(param_11);
highp vec4 _7265=_7263;
_7265.w=_3562;
highp vec4 param_12=_7257;
sc_writeFragData0(param_12);
highp vec4 param_13=_7249;
sc_writeFragData1(param_13);
highp vec4 param_14=_7265;
sc_writeFragData2(param_14);
#if (sc_OITMaxLayersVisualizeLayerCount)
{
highp vec4 param_15=vec4(0.00392157,0.0,0.0,0.0);
sc_writeFragData2(param_15);
}
#endif
}
#endif
}

void main()
{
highp float _7348;
if (overrideTimeEnable)
{
_7348=overrideTimeElapsed;
}
else
{
_7348=sc_Time.x;
}
highp float _7349;
if (overrideTimeEnable)
{
_7349=overrideTimeDelta;
}
else
{
_7349=sc_Time.y;
}
ssGlobals _7050=ssGlobals(_7348,_7349,_7352,varPackedTex.xy);
highp vec4 _7353;
#if (Tweak_N121)
{
highp vec2 _5126=((varPackedTex.xy-vec2(0.5))*vec2(uvScale))+vec2(0.5);
ssGlobals _5128=_7050;
highp vec4 _5127;
Node7_Texture_2D_Parameter(_5126,_5127,_5128);
_7353=_5127;
}
#else
{
_7353=vec4(1.0);
}
#endif
highp vec4 _4958=baseColor*_7353;
highp float _7355;
#if (Tweak_N308)
{
highp vec2 _5153=((varPackedTex.xy-vec2(0.5))*vec2(uvScale))+vec2(0.5);
ssGlobals _5155=_7050;
highp vec4 _5154;
Node0_Texture_2D_Parameter(_5153,_5154,_5155);
_7355=_5154.x;
}
#else
{
_7355=1.0;
}
#endif
highp float _4974=_4958.w*_7355;
highp vec4 _7064=vec4(_4958.x,_4958.y,_4958.z,vec4(0.0).w);
_7064.w=_4974;
#if (sc_BlendMode_AlphaTest)
{
if (_4974<alphaTestThreshold)
{
discard;
}
}
#endif
#if (ENABLE_STIPPLE_PATTERN_TEST)
{
if (_4974<((mod(dot(floor(mod(gl_FragCoord.xy,vec2(4.0))),vec2(4.0,1.0))*9.0,16.0)+1.0)*0.0588235))
{
discard;
}
}
#endif
highp vec4 param=_7064;
highp vec4 _4989=ngsPixelShader(param);
highp vec4 _4992=max(_4989,vec4(0.0));
highp vec4 param_1=_4992;
sc_writeFragData0(param_1);
highp vec4 _5215=clamp(_4992,vec4(0.0),vec4(1.0));
#if (sc_OITDepthBoundsPass)
{
#if (sc_OITDepthBoundsPass)
{
highp float _5275=clamp(viewSpaceDepth()*0.001,0.0,1.0);
highp vec4 _5270=vec4(max(0.0,1.00392-_5275),min(1.0,_5275+0.00392157),0.0,0.0);
sc_writeFragData0(_5270);
}
#endif
}
#else
{
#if (sc_OITDepthPrepass)
{
highp vec4 _5265=vec4(1.0);
sc_writeFragData0(_5265);
}
#else
{
#if (sc_OITDepthGatherPass)
{
highp vec4 _5207=_5215;
oitDepthGather(_5207);
}
#else
{
#if (sc_OITCompositingPass)
{
highp vec4 _5208=_5215;
oitCompositing(_5208);
}
#else
{
#if (sc_OITFrontLayerPass)
{
#if (sc_OITFrontLayerPass)
{
if (abs(gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,getScreenUV()).x)>getFrontLayerZTestEpsilon())
{
discard;
}
highp vec4 _5243=_5215;
sc_writeFragData0(_5243);
}
#endif
}
#else
{
highp vec4 _5210=_5215;
sc_writeFragData0(_5210);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
